<?php
	// Exit if accessed directly
	if( !defined( 'ABSPATH' ) ) exit;

	
	class mg2wpForo_asgaros extends wpForoMg2Board{
		private $forum_threads;

		public function __construct(){
			parent::__construct();
			
			$this->topic_table = 'forum_threads';
			if( !$this->db->get_var("SHOW TABLES LIKE '".$this->db->prefix . $this->topic_table . "'") ) 
				$this->topic_table = 'forum_topics';
		}

		public function get_users_count(){
			if( $count = $this->db->get_var("SELECT COUNT(*) FROM ".$this->db->base_prefix."users") ) return $count;
			return 0;
		}
		
		public function get_forums_count(){
			if( $count = $this->db->get_var("SELECT SUM(cnt) FROM (SELECT COUNT(*) AS cnt FROM `".$this->db->prefix."term_taxonomy` WHERE `taxonomy` = 'asgarosforum-category'
				UNION
				SELECT COUNT(*) FROM `".$this->db->prefix."forum_forums`) AS tbl") ) return $count;
			return 0;
		}
		
		public function get_topics_count(){
			if( $count = $this->db->get_var("SELECT COUNT(*) FROM `".$this->db->prefix . $this->topic_table . "`") ) return $count;
			return 0;
		}
		
		public function get_posts_count(){
			if( $count = $this->db->get_var("SELECT COUNT(*) FROM `".$this->db->prefix."forum_posts`") ) return $count;
			return 0;
		}
		
		public function get_extracats(){
			$sql = "SELECT tt.`term_taxonomy_id` AS old_id, 
				t.`name` AS title,
				t.`slug` AS slug,
				tt.`description` AS description
			FROM `".$this->db->prefix."term_taxonomy` tt
			INNER JOIN `".$this->db->prefix."terms` t ON t.`term_id` = tt.`term_id`
			WHERE tt.`taxonomy` = 'asgarosforum-category'
			ORDER BY old_id";
			return $this->db->get_results($sql, ARRAY_A);
		}
		
		public function get_forums(){
			$sql = "SELECT `id` AS old_id, 
				`name` AS title, 
				`description` AS description, 
				`parent_forum` AS parentid,
				`parent_id` AS extracat
			FROM `".$this->db->prefix."forum_forums`
			ORDER BY parentid, old_id";
			return $this->db->get_results($sql, ARRAY_A);
		}
		
		public function get_topics($lastid = 0){
			$sql = "SELECT t.`id` AS old_id, 
				p.`author_id` AS userid, 
				t.`name` AS title,
				p.`text` AS body, 
				t.`parent_id` AS forumid, 
				p.`date` AS created 
			FROM `".$this->db->prefix . $this->topic_table . "` t
			INNER JOIN `".$this->db->prefix."forum_posts` p ON p.`parent_id` = t.`id` AND p.`id` = 
			( SELECT MIN(f.`id`) FROM `".$this->db->prefix."forum_posts` f WHERE f.`parent_id` = t.`id` )
			WHERE t.`id` > $lastid
			ORDER BY t.`id`";
			return $this->db->get_results($sql.$this->limit, ARRAY_A);
		}
		
		public function get_replies($lastid = 0){
			$sql = "SELECT p.`id` AS old_id, 
				p.`author_id` AS userid, 
				CONCAT('RE: ', t.`name`) AS title, 
				p.`text` AS body, 
				t.`id` AS topicid, 
				p.`date` AS created
			FROM `".$this->db->prefix."forum_posts` p 
			INNER JOIN `".$this->db->prefix . $this->topic_table . "` t ON t.`id` = p.`parent_id`
			WHERE p.`id` != ( SELECT MIN(f.`id`) FROM `".$this->db->prefix."forum_posts` f WHERE f.`parent_id` = t.`id`  )
			AND p.`id` > $lastid
			ORDER BY old_id";
			return $this->db->get_results($sql.$this->limit, ARRAY_A);
		}
		
	}
	
	$this->asgaros = new mg2wpForo_asgaros();