<?php
	// Exit if accessed directly
	if( !defined( 'ABSPATH' ) ) exit;

	
	class mg2wpForo_bbPress extends wpForoMg2Board{
		public function get_users_count(){
			if( $count = $this->db->get_var("SELECT COUNT(*) FROM ".$this->db->base_prefix."users") ) return $count;
			return 0;
		}
		
		public function get_forums_count(){
			if( $count = $this->db->get_var("SELECT COUNT(*) FROM ".$this->db->prefix."posts WHERE post_status IN('publish', 'private', 'hidden', 'closed') AND post_type = 'forum'") ) return $count;
			return 0;
		}
		
		public function get_topics_count(){
			if( $count = $this->db->get_var("SELECT COUNT(*) FROM ".$this->db->prefix."posts WHERE post_status IN('publish', 'private', 'hidden', 'closed') AND post_parent <> 0 AND post_type = 'topic'") ) return $count;
			return 0;
		}
		
		public function get_posts_count(){
			if( $count = $this->db->get_var("SELECT COUNT(*) FROM ".$this->db->prefix."posts WHERE post_status IN('publish', 'private', 'hidden', 'closed') AND post_parent <> 0 AND post_type IN('topic', 'reply')") ) return $count;
			return 0;
		}
		
		public function get_forums(){
			$sql = "SELECT ID AS old_id, 
					post_title AS title, 
					post_name AS slug, 
					post_content AS description, 
					post_parent AS parentid 
				FROM ".$this->db->prefix."posts 
				WHERE post_status IN('publish', 'private', 'hidden', 'closed') 
					AND post_type = 'forum' 
				ORDER BY post_parent, ID";
			return $this->db->get_results($sql, ARRAY_A);
		}
		
		public function get_topics($lastid = 0){
			$sql = "SELECT ID AS old_id, 
					post_author AS userid, 
					post_title AS title, 
					post_name AS slug, 
					post_content AS body, 
					post_parent AS forumid, 
					post_date AS created,
					IF(post_status = 'private', 1, 0) AS private
				FROM ".$this->db->prefix."posts 
				WHERE ID > $lastid 
					AND post_status IN('publish', 'private', 'hidden', 'closed') 
					AND post_parent <> 0
					AND post_type = 'topic'
				ORDER BY 1";
			return $this->db->get_results($sql.$this->limit, ARRAY_A);
		}
		
		public function get_replies($lastid = 0){
			$sql = "SELECT ID AS old_id, 
					post_author AS userid, 
					post_title AS title, 
					post_content AS body, 
					post_parent AS topicid, 
					post_date AS created 
				FROM ".$this->db->prefix."posts 
				WHERE ID > $lastid
					AND post_status IN('publish', 'private', 'hidden', 'closed') 
					AND post_parent <> 0
					AND post_type = 'reply' 
				ORDER BY 1";
			return $this->db->get_results($sql.$this->limit, ARRAY_A);
		}
			
		public function get_sticky_topicids(){
			$sticky_topicids = array();
			$sql = "SELECT meta_value AS srlzs FROM ".$this->db->prefix."postmeta WHERE meta_key = '_bbp_sticky_topics'";
			if( $srlzs = $this->db->get_col($sql) ){
				foreach ($srlzs as $srlz) {
					$sticky_topicids = array_merge($sticky_topicids, unserialize($srlz));
				}
			}
			return $sticky_topicids;
		}

	}
	
	$this->bbpress = new mg2wpForo_bbPress();